﻿namespace MHQuestHelperLib
{
    public class MH2Tools
    {
        #region 公开属性
        public int QuestInfoPtr => GetQuestInfoPtr();
        public int CharactorScenePtr => GetCharactorScenePtr();
        public int BOSSInFoPtr => GetBOSSInFoPtr();
        public int QuestRewardPtr => GetQuestRewardPtr();
        public int SuppliesItemPtr => GetSuppliesItemPtr();
        public int ItemPointPtr => GetItemPointPtr();
        public int FishGroupPtr => GetFishGroupPtr();
        #endregion

        byte[] target;
        public MH2Tools(byte[] src) 
        {
            target = HexHelper.CopyByteArr(src);//加载数据
        }
        #region 指针查询类
        /// <summary>
        /// 任务信息指针
        /// </summary>
        /// <returns></returns>
        int GetQuestInfoPtr()
        {
            //从前4字节取出指针 定位任务信息位置
            return HexHelper.bytesToInt(target, 4, 0x00);
        }
        /// <summary>
        /// 任务信息指针
        /// </summary>
        /// <returns></returns>
        int GetCharactorScenePtr()
        {
            return HexHelper.bytesToInt(target, 4, 0x04);
        }
        /// <summary>
        /// BOSS(头部信息,指针
        /// </summary>
        /// <returns></returns>
        int GetBOSSInFoPtr()
        {
            return HexHelper.bytesToInt(target, 4, 0x18);
        }
        /// <summary>
        /// 取报酬组头部信息
        /// </summary>
        /// <returns></returns>
        int GetQuestRewardPtr()
        {
            return HexHelper.bytesToInt(target, 4, 0x0C);
        }
        /// <summary>
        /// 支援道具指针
        /// </summary>
        /// <returns></returns>
        int GetSuppliesItemPtr()
        {
            return HexHelper.bytesToInt(target, 4, 0x08);
        }
        /// <summary>
        /// 采集点指针
        /// </summary>
        /// <returns></returns>
        int GetItemPointPtr()
        {
            return HexHelper.bytesToInt(target, 4, 0x38);
        }
        /// <summary>
        /// 鱼群指针
        /// </summary>
        /// <returns></returns>
        int GetFishGroupPtr()
        {
            return HexHelper.bytesToInt(target, 4, 0x40);
        }
        #endregion

        #region 读取类

        #endregion

        #region 操作类

        #endregion
    }
}